// TA747.FDSW.c
// Copyright (c) 1998-1999 by Tony D'AMBROSIO.  All rights reserved.
//
// Flight Director SWitch for Vectorial Designed gauge RealCRT.PFD

#include	<windows.h>
#include	"gauges.h"
#include	"TA747.FDSW.h"

//	Set up import and export tables and gauge header
char		gauge_name[]		= "TA747-400.FDSW\0";
extern PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 50, gauge_name, &list );


#define GAUGE_CHARSET						DEFAULT_CHARSET
#define GAUGE_FONT_DEFAULT					"Courier New"
#define GAUGE_WEIGHT_DEFAULT				FW_NORMAL


FAILURE_RECORD	elec_fail[] =
{
	{FAIL_NONE, FAIL_ACTION_NONE}
};


// Globals
UINT32 FDMode = 0;
HANDLE hFileMap = NULL;	// File Mapping Object used to pass Mode between gauges
LPVOID lpMapAddress = NULL;
char szMode[] = "FDMode=0\0";


// ------ BUTTONS ----------------------------------------------------

MODULE_VAR_CB	icon_cb_FDMode;


ELEMENT_ICON	FDMode_switch=		// FD mode
{
	ELEMENT_TYPE_ICON,
	BMP_SW_P0,
	{24, 34},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_FDMode,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	3,
	0,
	0,
	NULL,
	NULL
};

// ----- List definition -------------------------------

PELEMENT_HEADER		plist[] =
{
	&FDMode_switch.header,
	NULL
};

ELEMENT_STATIC_IMAGE		background	=
{
	ELEMENT_TYPE_STATIC_IMAGE,
	BMP_BACKLIGHT,
	{0,0},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	(PPELEMENT_HEADER)&plist,
	NULL,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
0,0
};

PELEMENT_HEADER		list	= &background.header;

// ----- Mouse -------------------------
MOUSE_FUNCTION	mouse_pos0;
MOUSE_FUNCTION	mouse_pos1;
MOUSE_FUNCTION	mouse_pos2;

MOUSE_BEGIN( mouse_rect, HELP_NONE, 0, 0 )
	MOUSE_CHILD_FUNCT( 9, 22, 28, 26, CURSOR_HAND, MOUSE_LEFTSINGLE|MOUSE_DOWN_REPEAT, mouse_pos0)
	MOUSE_CHILD_FUNCT( 37, 12, 28, 21, CURSOR_HAND, MOUSE_LEFTSINGLE|MOUSE_DOWN_REPEAT, mouse_pos1)
	MOUSE_CHILD_FUNCT( 65, 22, 28, 26, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_pos2)
MOUSE_END

//- CALLBACK FUNCTIONS ------------------------------------------------------

//- Mouse -----------------------------------------
BOOL FSAPI mouse_pos0(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	FDMode = 0;
	wsprintf(&szMode[7], "%d", FDMode);
	if(lpMapAddress)
		memcpy((LPDWORD)lpMapAddress, szMode, 10);	// Write data
	return FALSE; 
}

BOOL FSAPI mouse_pos1(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	FDMode = 1;
	wsprintf(&szMode[7], "%d", FDMode);
	if(lpMapAddress)
		memcpy((LPDWORD)lpMapAddress, szMode, 10);	// Write data
	return FALSE;
}

BOOL FSAPI mouse_pos2(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	FDMode = 2;
	wsprintf(&szMode[7], "%d", FDMode);
	if(lpMapAddress)
		memcpy((LPDWORD)lpMapAddress, szMode, 10);	// Write data
	return FALSE;
}

//- Icons -----------------------------------------
FLOAT64 FSAPI	icon_cb_FDMode( PMODULE_VAR var )
{
	return FDMode;
}


//---------------------------------------------------------------------------
void FSAPI	install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
	// Create file mapping object to pass parameters to RealCRT.PFD
	hFileMap = CreateFileMapping((HANDLE)0xFFFFFFFF, NULL, PAGE_READWRITE, 0, 20, "PassData");
	if(hFileMap)
		lpMapAddress = MapViewOfFile(hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if(lpMapAddress)
		memcpy((LPDWORD)lpMapAddress, szMode, 10);	// Write data
}


//---------------------------------------------------------------------------
void FSAPI	initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI	update_routine()
{
	element_list_update( list );
	if(lpMapAddress)
	{
		memcpy(szMode, (LPDWORD)lpMapAddress, 10);	// Read data
		FDMode = atoi(&szMode[7]);
	}
}


//---------------------------------------------------------------------------
void FSAPI	generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI	draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI	kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
	// Release mapping objects
	UnmapViewOfFile(lpMapAddress);
	CloseHandle(hFileMap);
}

