// TA7x7.ND.MCP.c
// Copyright (c) 1998-1999 by Tony D'AMBROSIO.  All rights reserved.
//
// Mode Control Panel - ND Mode Selectors for RealCRT.ND v2.x (Navigation Display)
// Separated from AutoPilot commands

#include	<windows.h>
#include	<stdio.h>
#include	"gauges.h"
#include	"TA7x7.ND.MCP.h"

//	Set up import and export tables and gauge header
char		gauge_name[]		= "TA7x7.ND.MCP\0";
extern PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 140, gauge_name, &list );


#define GAUGE_CHARSET						DEFAULT_CHARSET
#define GAUGE_FONT_DEFAULT					"Courier New"
#define GAUGE_WEIGHT_DEFAULT				FW_NORMAL


FN_FLOAT64	update_string_vor1_OBI;

FAILURE_RECORD	elec_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

// Globals for ND mode switches
UINT32 MapMode = 0;		// 0=VOR, 1=MAP, 2=Plan
UINT32 MapItem = 0x1E;	// Bit0=WXR, Bit1=WPT, Bit2=VORD, Bit3=NDB, Bit4=ARPT (All actives at startup, but WXR)
UINT32 Range = 320;
char szMap[]	= "MapMode=0\0";
char szItem[]	= "Item=0x1E\0";
char szRange[]	= "Range=320\0";
HANDLE hFileMap = NULL;	// File Mapping Object used to pass Mode between gauges
LPVOID lpMapAddress = NULL;

// Sequence
SEQ_REC seq_obi1[]  =
{
	{SELECT_VOR1, 0, 2},
	{SELECT_NONE, 0, 0}
};


ELEMENT_STRING vor1_OBI =
{
	ELEMENT_TYPE_STRING,
	-1,
	{41, 4},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_ERASE | IMAGE_USE_BRIGHT,
	0,0,

	{{VOR1_OBI}, {MODULE_VAR_NONE}, {MODULE_VAR_NONE}},		// source_var
	{ 0, 0, 0},								// save_var
	{ NULL,	NULL, NULL },					// key selection fn
	update_string_vor1_OBI,					// update fuction
	NULL,									// string
	NULL,									// string old
	{30, 16},								// requested size (15 = minimum value)
	NULL,									// string_data
	NULL,									// save_buffer
	RGB(255,255,255),						// forecolor
	RGB(0,0,0),								// backcolor
	RGB(255,255,0),							// hilight old
	0,										// hdc
	0,										// hfont
	0,										// hfont_old
	0,										// hbmp
	0,										// hbmp_old
	0,										// hbrush
	0,										// hbrush_old
	GAUGE_FONT_DEFAULT,						// font name
	GAUGE_WEIGHT_DEFAULT,					// font weight
	GAUGE_CHARSET,							// font charset
	0,										// DrawText Flags
	3,
	0, 0, 0,
	seq_obi1,
	0
};

// ------ BUTTONS ----------------------------------------------------

MODULE_VAR_CB	icon_cb_NDMode;
MODULE_VAR_CB	icon_cb_WXR;
MODULE_VAR_CB	icon_cb_WPT;
MODULE_VAR_CB	icon_cb_VORD;
MODULE_VAR_CB	icon_cb_NDB;
MODULE_VAR_CB	icon_cb_ARPT;
MODULE_VAR_CB	icon_cb_Range;


ELEMENT_ICON	NDMode_switch=		// ND mode
{
	ELEMENT_TYPE_ICON,
	BMP_MODE_VOR,
	{16, 36},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_NDMode,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	3,
	0,
	0,
	NULL,
	NULL
};

ELEMENT_ICON	Map_WXR=
{
	ELEMENT_TYPE_ICON,
	BMP_PUSH_ON,
	{0, 61},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_WXR,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	2,
	0,
	0,
	NULL,
	NULL
};

ELEMENT_ICON	Map_WPT=
{
	ELEMENT_TYPE_ICON,
	BMP_PUSH_ON,
	{26, 61},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_WPT,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	2,
	0,
	0,
	NULL,
	NULL
};

ELEMENT_ICON	Map_VORD=
{
	ELEMENT_TYPE_ICON,
	BMP_PUSH_ON,
	{52, 61},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_VORD,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	2,
	0,
	0,
	NULL,
	NULL
};

ELEMENT_ICON	Map_NDB=
{
	ELEMENT_TYPE_ICON,
	BMP_PUSH_ON,
	{78, 61},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_NDB,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	2,
	0,
	0,
	NULL,
	NULL
};

ELEMENT_ICON	Map_ARPT=
{
	ELEMENT_TYPE_ICON,
	BMP_PUSH_ON,
	{104, 61},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_ARPT,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	2,
	0,
	0,
	NULL,
	NULL
};

ELEMENT_ICON	Range_commutator=
{
	ELEMENT_TYPE_ICON,
	BMP_RANGE_10,
	{69, 36},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	NULL,
	IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
	0,0,

	{MODULE_VAR_NONE},
	icon_cb_Range,
	ICON_SWITCH_TYPE_SET_CUR_ICON,
	0,
	0,
	0,
	7,
	0,
	0,
	NULL,
	NULL
};


// ------ Backlight -------------------------

ELEMENT_STATIC_IMAGE		backlight	=
{
	ELEMENT_TYPE_STATIC_IMAGE,
	BMP_BACKLIGHT,
	{0,0},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	NULL,
	(PFAILURE_RECORD)elec_fail,
	IMAGE_USE_TRANSPARENCY | IMAGE_USE_BRIGHT,
0,0
};


// ----- List definition -------------------------------

PELEMENT_HEADER		plist[] =
{
	&backlight.header,
	&vor1_OBI.header,
	&NDMode_switch.header,
	&Map_WXR.header,
	&Map_WPT.header,
	&Map_VORD.header,
	&Map_NDB.header,
	&Map_ARPT.header,
	&Range_commutator.header,
	NULL
};

ELEMENT_STATIC_IMAGE		background	=
{
	ELEMENT_TYPE_STATIC_IMAGE,
	BMP_BACKGROUND,
	{0,0},
	{0,0},
	{0,0},
	&gauge_header,
	NULL,
	(PPELEMENT_HEADER)&plist,
	NULL,
	IMAGE_USE_TRANSPARENCY,
0,0
};

PELEMENT_HEADER		list	= &background.header;

// ----- Mouse -------------------------
MOUSE_FUNCTION	mouse_rose_MAP;
MOUSE_FUNCTION	mouse_rose_VOR;
MOUSE_FUNCTION	mouse_arc_MAP;
MOUSE_FUNCTION	mouse_arc_VOR;
MOUSE_FUNCTION	mouse_plan;
MOUSE_FUNCTION	mouse_WXR;
MOUSE_FUNCTION	mouse_WPT;
MOUSE_FUNCTION	mouse_VORD;
MOUSE_FUNCTION	mouse_NDB;
MOUSE_FUNCTION	mouse_ARPT;
MOUSE_FUNCTION	mouse_range_inc;
MOUSE_FUNCTION	mouse_range_dec;


MOUSE_BEGIN( mouse_rect, HELP_NONE, 0, 0 )
	// Course
	MOUSE_PARENT( 34, 2, 44, 18, HELPID_B737_AUTOPILOT_COURSE_SELECT)
	MOUSE_CHILD_EVENT( 116, 2, 15, 22, CURSOR_UPARROW, MOUSE_LEFTSINGLE|MOUSE_DOWN_REPEAT, KEY_VOR1_OBI_INC)
	MOUSE_CHILD_EVENT( 116-15, 2, 15, 22, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE|MOUSE_DOWN_REPEAT, KEY_VOR1_OBI_DEC)
	// ND Mode
	MOUSE_CHILD_FUNCT( 18, 21, 25, 13, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_arc_MAP)
	MOUSE_CHILD_FUNCT( 0, 29, 18, 21, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_arc_VOR)
	MOUSE_CHILD_FUNCT( 43, 29, 12, 21, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_plan)
	// Map Mode
	MOUSE_CHILD_FUNCT( 1, 75, 23, 15, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_WXR)
	MOUSE_CHILD_FUNCT( 27, 75, 23, 15, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_WPT)
	MOUSE_CHILD_FUNCT( 53, 75, 23, 15, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_VORD)
	MOUSE_CHILD_FUNCT( 79, 75, 23, 15, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_NDB)
	MOUSE_CHILD_FUNCT( 105, 75, 23, 15, CURSOR_HAND, MOUSE_LEFTSINGLE, mouse_ARPT)
	// Range INC
	MOUSE_CHILD_FUNCT( 82, 29, 30, 21, CURSOR_UPARROW, MOUSE_LEFTSINGLE, mouse_range_inc)
	// Range DEC
	MOUSE_CHILD_FUNCT( 82-24, 29, 24, 21, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE, mouse_range_dec)
MOUSE_END

//- CALLBACK FUNCTIONS ------------------------------------------------------

//- Mouse -----------------------------------------

BOOL FSAPI mouse_arc_MAP(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapMode = 1;	// Map
	wsprintf(&szMap[8], "%d", MapMode);
	if(lpMapAddress)
	{
		memcpy((LPBYTE)lpMapAddress+10, szMap, 10);
	}
	return FALSE;
}

BOOL FSAPI mouse_arc_VOR(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapMode = 0;	// VOR
	wsprintf(&szMap[8], "%d", MapMode);
	if(lpMapAddress)
	{
		memcpy((LPBYTE)lpMapAddress+10, szMap, 10);
	}
	return FALSE;
}

BOOL FSAPI mouse_plan(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapMode = 2;	// Plan
	wsprintf(&szMap[8], "%d", MapMode);
	if(lpMapAddress)
	{
		memcpy((LPBYTE)lpMapAddress+10, szMap, 10);
	}
	return FALSE;
}

BOOL FSAPI mouse_WXR(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapItem = MapItem ^ 0x01;
	sprintf(&szItem[7], "%02X", MapItem);
	if(lpMapAddress)
		memcpy((LPBYTE)lpMapAddress+20, szItem, 10);	// Write data
	return FALSE;
}

BOOL FSAPI mouse_WPT(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapItem = MapItem ^ 0x02;
	sprintf(&szItem[7], "%02X", MapItem);
	if(lpMapAddress)
		memcpy((LPBYTE)lpMapAddress+20, szItem, 10);	// Write data
	return FALSE;
}

BOOL FSAPI mouse_VORD(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapItem = MapItem ^ 0x04;
	sprintf(&szItem[7], "%02X", MapItem);
	if(lpMapAddress)
		memcpy((LPBYTE)lpMapAddress+20, szItem, 10);	// Write data
	return FALSE;
}

BOOL FSAPI mouse_NDB(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapItem = MapItem ^ 0x08;
	sprintf(&szItem[7], "%02X", MapItem);
	if(lpMapAddress)
		memcpy((LPBYTE)lpMapAddress+20, szItem, 10);	// Write data
	return FALSE;
}

BOOL FSAPI mouse_ARPT(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	MapItem = MapItem ^ 0x10;
	sprintf(&szItem[7], "%02X", MapItem);
	if(lpMapAddress)
		memcpy((LPBYTE)lpMapAddress+20, szItem, 10);	// Write data
	return FALSE;
}

BOOL FSAPI mouse_range_inc(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	if(Range<640)
	{
		Range = Range*2;
		sprintf(&szRange[6], "%03d", Range);
		if(lpMapAddress)
			memcpy((LPBYTE)lpMapAddress+30, szRange, 10);	// Write data
	}
	return FALSE;
}

BOOL FSAPI mouse_range_dec(PPIXPOINT relative_point, FLAGS32 mouse_flags) 
{
	if(Range>10)
	{
		Range = Range/2;
		sprintf(&szRange[6], "%03d", Range);
		if(lpMapAddress)
			memcpy((LPBYTE)lpMapAddress+30, szRange, 10);	// Write data
	}
	return FALSE;
}


//- Icons -----------------------------------------
FLOAT64 FSAPI	icon_cb_NDMode( PMODULE_VAR var )
{
	return MapMode;
}

FLOAT64 FSAPI	icon_cb_WXR( PMODULE_VAR var )
{
	return(!(MapItem & 0x01));
}

FLOAT64 FSAPI	icon_cb_WPT( PMODULE_VAR var )
{
	return(!((MapItem & 0x02)/2));
}

FLOAT64 FSAPI	icon_cb_VORD( PMODULE_VAR var )
{
	return(!((MapItem & 0x04)/4));
}

FLOAT64 FSAPI	icon_cb_NDB( PMODULE_VAR var )
{
	return(!((MapItem & 0x08)/8));
}

FLOAT64 FSAPI	icon_cb_ARPT( PMODULE_VAR var )
{
	return(!((MapItem & 0x10)/16));
}

FLOAT64 FSAPI	icon_cb_Range( PMODULE_VAR var )
{
	switch(Range)
	{
	case 10:
		return 0;
	case 20:
		return 1;
	case 40:
		return 2;
	case 80:
		return 3;
	case 160:
		return 4;
	case 320:
		return 5;
	case 640:
		return 6;
	}
}


// ---- Strings ---------------------------------------------

FLOAT64 FSAPI	update_string_vor1_OBI ( FLOAT64 val )
{
	wsprintf(vor1_OBI.string, "%03d", (UINT32)val);
	return val;
}

//---------------------------------------------------------------------------
void FSAPI	install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
	// Create file mapping object to pass parameters to RealCRT.ND
	hFileMap = CreateFileMapping((HANDLE)0xFFFFFFFF, NULL, PAGE_READWRITE, 0, 60, "NDPassData");
	if(hFileMap)
		lpMapAddress = MapViewOfFile(hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if(lpMapAddress)
	{
//		memcpy((LPBYTE)lpMapAddress, szMode, 10);		// Write data
		memcpy((LPBYTE)lpMapAddress+10, szMap, 10);
		memcpy((LPBYTE)lpMapAddress+20, szItem, 10);
		memcpy((LPBYTE)lpMapAddress+30, szRange, 10);
	}
}


//---------------------------------------------------------------------------
void FSAPI	initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI	update_routine()
{
	element_list_update( list );
	if(lpMapAddress)
	{
//		memcpy(szMode, (LPBYTE)lpMapAddress, 10);	// Read data
//		NDMode = atoi(&szMode[7]);
		memcpy(szMap, (LPBYTE)lpMapAddress+10, 10);
		MapMode = atoi(&szMap[8]);
		memcpy(szItem, (LPBYTE)lpMapAddress+20, 10);
		sscanf(&szItem[5], "%X", &MapItem);
		memcpy(szRange, (LPBYTE)lpMapAddress+30, 10);
		Range = atoi(&szRange[6]);
	}
}


//---------------------------------------------------------------------------
void FSAPI	generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI	draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI	kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
	// Release mapping objects
	UnmapViewOfFile(lpMapAddress);
	CloseHandle(hFileMap);
}

